function Is() {}

Is.callToString = function(arg) {
    return Object.prototype.toString.call(arg)
};

Is.$string = function(arg) {
    return Is.callToString(arg) === '[object String]';
};

Is.is = function(arg, type){
    if (!Is.$string(type)) throw new Error('The "type" must be a String');
    let response = Is.callToString(arg) === `[object ${type}]`;
    if (!response) response = eval(`arg instanceof ${type}`);
    return response;
};

Is.$array = function(arg){
    return Is.is(arg, 'Array');
};

Is.$null = function(arg){
    return Is.is(arg, 'Null');
};

Is.$number = function(arg){
    return Is.is(arg, 'Number');
};

Is.$object = function(arg){
    return Is.is(arg, 'Object');
};

Is.$undefined = function(arg){
    return Is.is(arg, 'Undefined');
};

Is.$boolean = function(arg){
    return Is.is(arg, 'Boolean');
};

Is.$function = function(arg){
    return Is.is(arg, 'Function');
};

module.exports = Is;